.composer:
  image: php:7.2-cli
  before_script:
    - apt-get update
    - apt-get install zip unzip git -yqq
    - pecl install xdebug && docker-php-ext-enable xdebug
    - php -r "copy('https://getcomposer.org/installer', 'composer-setup.php');"
    - php composer-setup.php
    - php -r "unlink('composer-setup.php');"
    - php composer.phar install

stages:
  - lint
  - test
  - quality

lint:
  stage: lint
  extends:
    - .composer
  image : php:7.2-cli
  script:
    - php composer.phar phpcs

test:
  stage: test
  extends:
    - .composer
  variables:
    XDEBUG_MODE: coverage
  script:
    - php composer.phar test-coverage
  artifacts:
    paths:
      - coverage
    expire_in: 1h

quality:
  stage: quality
  only:
    - develop
  image: gitlab.libriciel.fr:4567/docker/sonar-scanner:latest
  script:
    - /sonar-scanner -Dsonar.login=$SONAR_LOGIN -Dsonar.host.url=$SONAR_HOST_URL
